//
// Elke Schmidtke, University of Potsdam
// eschmidt@geo.uni-potsdam.de

public class CalibrationValues
{
     int numOfZeros;
     int numOfPoles;
     double scaleFak;
     ComplexValue poles[];
     ComplexValue zeros[];
     int paarPoles[];
     int paarZeros[];
     
    CalibrationValues ()
    { 
	numOfZeros = -1;
	numOfPoles = -1; 
    }
    
    public boolean haveCalibration()
    {
	if (numOfZeros == -1 || numOfPoles == -1)
	    return false;
	return true;
    }
    
    public void deleteCalibration ()
    {
	numOfZeros = numOfPoles = -1;
    }
    
    public void setPaarPoles()
    {
	int i,j,p;
	
	paarPoles = new int [numOfPoles];
	for (i = 0; i < numOfPoles; i++)
	     paarPoles[i] = -1;
	for (i = 0, p = 1; i < numOfPoles; i++)
	    for (j = 0; j < numOfPoles; j++)	
		if (i != j && poles[i].r == poles[j].r && poles[i].i == -poles[j].i)
		    if(paarPoles[i] == -1 && paarPoles[j] == -1)
		    {
			paarPoles[i] = paarPoles[j] = p;
			p++;
		    }
	for (i = 0; i < numOfPoles; i++)
	    if (paarPoles[i] == -1 && poles[i].i == 0)
	   	paarPoles[i] = 0; 
    } 
    
    public void setPaarZeros()
    {
	int i,j,p;
	
	paarZeros = new int [numOfZeros];
	for (i = 0; i < numOfZeros; i++)
	     paarZeros[i] = -1;
	for (i = 0, p = 1; i < numOfZeros; i++)
	    for (j = 0; j < numOfZeros; j++)	
		if(paarZeros[i] == -1 && paarZeros[j] == -1)
		    if (i != j && zeros[i].r == zeros[j].r && zeros[i].i == -zeros[j].i)
		    {
			paarZeros[i] = paarZeros[j] = p;
			p++;
		    }
	for (i = 0; i < numOfZeros; i++)
	    if (paarZeros[i] == -1 && zeros[i].i == 0)
	   	paarZeros[i] = 0;
    } 
    
    public boolean PolTest()
    {
      int i;
      boolean gef;
	setPaarPoles();
	for (i = 0; i < numOfPoles; i++)
	    if (paarPoles[i] == -1)
		return false;
	return true;
    }  
  
     public void newCalibration (CalibrationValues v)
     {
	numOfZeros = v.numOfZeros;
	numOfPoles = v.numOfPoles;
	scaleFak = v.scaleFak;
	poles = v.poles;
        zeros = v.zeros;
        paarPoles = v.paarPoles;
	setPaarPoles();
	setPaarZeros();
     }     
}   
 