//
// Elke Schmidtke, University of Potsdam
// eschmidt@geo.uni-potsdam.de

import java.awt.*;
import java.lang.*;
import java.awt.event.*;
import java.text.*;

abstract class GraphCanvas extends Canvas
implements MouseListener, MouseMotionListener
{
    WinGroup wg;
    int width,height,height2,deltaH;
    int pwidth,pheight;
    
    Image image = null;
    
    static Color cLineText = Color.black,
		 cLines = Color.black,
		 cKoordLines = Color.lightGray,
		 cPoints = Color.red,
		 cPoles = Color.red,
		 cZoom = Color.yellow,
		 cPoints_new = new Color(200,100,255), 
		 cZeros = Color.blue,
		 cBackground = Color.white;
    		 
    static int FontHeight = 12;
    static Font fSmall = new Font ("Arial", Font.PLAIN, FontHeight);
  
  public void setLabel(String text)
  {
	Container parent = getParent();
	((WinShowGraph)parent).setMainLabelText (text);
  }
   
  public String getLabel()
  {
	Container parent = getParent();
	return ((WinShowGraph)parent).getMainLabelText ();
  } 
  
  protected double FindSpace (double diff)
  {
    double space = 1.0f;
	while(diff > 5) {		
	    if(diff/space <= 11) break;   else space *= 2;
	    if(diff/space <= 11) break;   else space *= 2;
	    if(diff/space <= 11) break;   else space *= 1.25;
	    if(diff/space <= 11) break;   else space *= 2;
	} while(diff <= 5) {	
	    if(diff/space > 5) break;    else space /= 2;
	    if(diff/space > 5) break;    else space /= 1.25;
	    if(diff/space > 5) break;    else space /= 2;
	    if(diff/space > 5) break;    else space /= 2;
	}
	return (space);
  }  

  protected String valStr (double wert)
  {
    String str, substr, str1;
    int len, pos, p;
	DecimalFormat nf = new DecimalFormat();
	nf.setGroupingUsed (false);
	nf.setMaximumFractionDigits(5);
	
	str1 = (new Double (wert)).toString();
	if ((p = str1.indexOf('E')) != -1 && str1.length() <= 9)
	    return str1;
	if (p != -1)
	{
	    double val = (Double.valueOf(str1.substring (0,p))).doubleValue();
	    long rw = Math.round (val);
	    if (rw == 10)
	    {
		int exp = (Integer.valueOf(str1.substring (p+1, str1.length()))).intValue();
		return ("1.0E"+(++exp));
	    }
	    else
		return ((new Float(rw)).toString() + str1.substring (p, str1.length()));
	}
	str = nf.format(wert); 
	if ((pos = str.indexOf('.')) != -1)
	{  
	    int n = Integer.valueOf (str.substring(pos+1)).intValue();
	    if (n == 0)
	   	return (str.substring (0,pos));
	}	
	len = str.length(); 
	if (len > 9) str= " ";
	return (str);
  }
    
}    