//
// Elke Schmidtke, University of Potsdam
// eschmidt@geo.uni-potsdam.de

import java.awt.event.*;
import java.awt.*;
import java.net.*;

class NewValuesCommand extends Command
{
    public NewValuesCommand (int id, WinGroup wg)
    { 
	super (id, wg);
    }
    
    public void actionPerformed (ActionEvent e)
    {
	String s = e.getActionCommand();
    
	if (s.equals (cancelSt)) {
	    wg.editor.setVisible(false);
	    return;
	}
 
	switch (id) {
	    case GSECALIBRATIONFILE:
		String file = wg.editor.getSelectedItem (chooseGseCalibrationFileSt);
		if (file != null) {
		    String url_string = wg.tutor.codeBase+wg.Dir_calVal+file;
		    try {
			URL url_file = new URL (url_string);
			CalibrationValues cali = new CalibrationValues ();
			if (wg.ServerConnection.CalibrationFromFile (url_file, cali)) {
			    wg.CalVal.newCalibration(cali);
			    wg.showPolZer.graph.G_Initalize_Poles_Zeros();
			    wg.PolesZeros.newValues(cali);
			    if (wg.showPolZer.isShowing()) wg.showPolZer.graph.repaint();
			    wg.actionPerformed 
				(new ActionEvent (this, Event.ACTION_EVENT, "acceptNewValues"));
			}	
		    }
		    catch (Exception ex) {
			wg.message.setVisible (ex.toString());
			return;	
		    }
		} else return;
		break;
	} 
	
	if (s.equals (okSt))
	    wg.editor.setVisible(false);
    }
}