//
// Elke Schmidtke, University of Potsdam
// eschmidt@geo.uni-potsdam.de

import java.util.Vector;

public class Parameter implements Definitions {
    Command command = null;
    double setupFrequency = setupDefaultFrequency;
    int setupPoints = setupDefaultPoints;
    int setupSpike = setupDefaultSpike;
    int setupStep = setupDefaultStep;
    double sinusAmplitude = 1;
    double sinusFreqency = 0.4;
    double sinusPhase = 0;
    double constantAmplitude = 1;
    double rickerFrequency = 0.2;
    double bruneRth = 0.625;
    double bruneSigma = 50.0;
    double bruneMu = 3.0E10;
    double bruneVs = 3.5;
    double bruneR = 1.0;
    double bruneZ = 20.0;
    double mixedAmplitude = 1;
    double mixedFrequency = 0.4;
    double mixedPhase = 0;
    double mixedB = 3.50;
    double mixedC = 1.000;
    double mixedD = 20.00;
    double chirpAmplitude = 1;
    double chirpFrequency1 = 1;
    double chirpPhase = 0;
    double chirpFrequency2 = 0.1;
    double seismometerFrequency = 3;
    double seismometerDamping = .4;
    String dataTraceFile = new String();
    double dataTraceFrequency = 20;
    Vector spikesAmplitude = null;
    Vector spikesIndex = null;
    double movingAverageWindow = 1;
    int interpolationFactor = 2;
    double discretizationFrequency = 10;
    double reconstructionFrequency = 10;
    int decimateFactor = 1;
    int decimateForce;
    double plainADCFrequency = 100;;
    double plainADCGain = 1.0;
    double plainADCLSB = 0.1;
    int plainADCMantissa = 12;
    int plainADCExponent = 0;
    int decimationFilteringDecratio;
    double fir2causFdig = -1;
    int fir2causZerosAppend = 0;
    String fir2causFile = new String ();
    boolean fir2causCorrect_time;
    double butterworthLPLowFrequncy = 1.0;
    int butterworthLPSection = 1;
    String butterworthLPzeroPhase = new String();
    double butterworthBPLowFrequncy = 1.0;
    double butterworthBPHighFrequncy = 50.0;
    int butterworthBPSection = 1;
    String butterworthBPzeroPhase = new String();
    double butterworthHPHighFrequncy = 50.0;
    int butterworthHPSection = 1;
    String butterworthHPzeroPhase = new String();
    Vector diffEquMaCoef = null;
    Vector diffEquArCoef = null;
    double diffEquGain = 1;
    int pointsFilterWithGSECalib;
    
  double getSetupFrequency()		{ return setupFrequency; }
  int getSetupPoints()			{ return setupPoints; }
  int getSetupDefaultPoints()		{ return setupDefaultPoints; }
  int getSetupSpikePosition()		{ return setupSpike; }
  int getSetupStepPosition()		{ return setupStep; }
  int getInterpolationFactor()		{ return interpolationFactor; }
  double getSinusAmplitude ()		{ return sinusAmplitude; }
  double getSinusFreqency ()		{ return sinusFreqency; }
  double getSinusPhase ()		{ return sinusPhase; }
  double getConstantAmplitude()		{ return constantAmplitude; }
  double getRickerFrequency()		{ return rickerFrequency; }
  double getBruneSigma()		{ return bruneSigma; }
  double getBruneRth()			{ return bruneRth; }
  double getBruneMu()			{ return bruneMu; }
  double getBruneVs()			{ return bruneVs; }
  double getBruneR()			{ return bruneR; }
  double getBruneZ()			{ return bruneZ; }
  double getMixedAmplitude()		{ return mixedAmplitude; }
  double getMixedFrequency()		{ return mixedFrequency; }
  double getMixedPhase()		{ return mixedPhase; }
  double getMixedB()			{ return mixedB; }
  double getMixedC()			{ return mixedC; }
  double getMixedD()			{ return mixedD; }
  double getChirpAmplitude()		{ return chirpAmplitude; }
  double getChirpFrequency1()		{ return chirpFrequency1; }
  double getChirpPhase()		{ return chirpPhase; }
  double getChirpFrequency2()		{ return chirpFrequency2; }
  double getSeismometerFrequency()	{ return seismometerFrequency; } 
  double getSeismometerDamping()        { return seismometerDamping; }
  double getMovingAverageWindow()       { return movingAverageWindow; }
  double getDiscretizationFrequency()	{ return discretizationFrequency; } 
  double getPlainADCFrequency()		{ return plainADCFrequency; }
  double getPlainADCGain()		{ return plainADCGain; }
  double getPlainADCLSB()		{ return plainADCLSB; }
  String getDataTraceFile()		{ return dataTraceFile; }
  double getDataTraceFrequency()	{ return dataTraceFrequency; }
  Vector getSpikesAmplitude()		{ return spikesAmplitude; }
  Vector getSpikesIndex()		{ return spikesIndex; }
  int getPlainADCMantissa()		{ return plainADCMantissa; }
  int getPlainADCExponent()		{ return plainADCExponent; }
  double getFir2causFdig()		{ return fir2causFdig; }
  int getFir2causZerosAppend()		{ return fir2causZerosAppend; }
  double getButterworthBPLowFrequncy()	{ return butterworthBPLowFrequncy; }
  double getButterworthBPHighFrequncy()	{ return butterworthBPHighFrequncy; }
  int getButterworthBPSection()		{ return butterworthBPSection; }
  double getButterworthLPLowFrequncy()	{ return butterworthLPLowFrequncy; }
  int getButterworthLPSection()		{ return butterworthLPSection; }
  double getButterworthHPHighFrequncy()	{ return butterworthHPHighFrequncy; }
  int getButterworthHPSection()		{ return butterworthHPSection; }
  Vector getDiffEquMaCoef()		{ return diffEquMaCoef; }
  Vector getDiffEquArCoef()		{ return diffEquArCoef; }
  double getDiffEquGain()		{ return diffEquGain; }
  int getDecimateFactor()		{ return decimateFactor; }
  int getDecimateForce()		{ return decimateForce; }

  void saveParameter (Command cmd, double val1, int val2, int val3, int val4)
  { 
    switch (cmd.id) {
	case SETUPMODIFY:
	case SETUPRESET:
	    setupFrequency = val1;
	    setupPoints = val2;
	    setupSpike = val3;
	    setupStep = val4;
	    break;
    }
  }

  void saveParameter (Command cmd, Vector v1, Vector v2)
  {
    switch (cmd.id) {
	case SPIKES:
	    spikesAmplitude = v1;
	    spikesIndex = v2;
	    break;
	case DIFFERENCEEQUATION:
	    diffEquMaCoef = v1;
	    diffEquArCoef = v2;
	    break;
    }
  }
  
  boolean saveParameter (Command cmd, boolean b)
  {
    switch (cmd.id) {
	case FIR2CAUS:
	    if (cmd == command && fir2causCorrect_time == b) return false;
	    fir2causCorrect_time = b;
	    break;
    }
    command = cmd;
    return true;
  }
 
  boolean saveParameter (Command cmd, String s)
  {
    switch (cmd.id) {
	case FIR2CAUS:
	    if (cmd == command && fir2causFile.equals(s)) return false;
	    fir2causFile = s;
	    break;
	case BUTTERWORTH_BP:
	    if (cmd == command && butterworthBPzeroPhase.equals(s)) return false;
	    butterworthBPzeroPhase = s;
	    break;
	case BUTTERWORTH_LP:
	    if (cmd == command && butterworthLPzeroPhase.equals(s)) return false;
	    butterworthLPzeroPhase = s;
	    break;
	case BUTTERWORTH_HP:
	    if (cmd == command && butterworthHPzeroPhase.equals(s)) return false;
	    butterworthHPzeroPhase = s;
	    break;
	case DATATRACE:
	    dataTraceFile = s;
	    break;
    }
    command = cmd;
    return true;
  }
     
  boolean saveParameter (Command cmd, int val)
  {
    switch (cmd.id) {
	case INTERPOLATE:
	    if (interpolationFactor == val && cmd == command) return false;
	    interpolationFactor = val; 
	    break;   
	case DECIMATIONFILTERING:
	    if (decimationFilteringDecratio == val && cmd == command) return false;
	    decimationFilteringDecratio = val; 
	    break; 
	case FIR2CAUS:
	    if (fir2causZerosAppend == val && cmd == command) return false;
	    fir2causZerosAppend = val; 
	    break;
	case BUTTERWORTH_BP:
	    if (cmd == command && butterworthBPSection == val) return false;
	    butterworthBPSection = val;
	    break;
	case BUTTERWORTH_LP:
	    if (cmd == command && butterworthLPSection == val) return false;
	    butterworthLPSection = val;
	    break;
	case BUTTERWORTH_HP:
	    if (cmd == command && butterworthHPSection == val) return false;
	    butterworthHPSection = val;
	    break;
	case FILTERWITHGSECALIB:
	    if (cmd == command && pointsFilterWithGSECalib == val) return false;
	    pointsFilterWithGSECalib = val;
	    break;
    }
    command = cmd;
    return true;
  } 

  boolean saveParameter (Command cmd, double val)
  {
    switch (cmd.id) {
	case CONSTANT:
	    if (constantAmplitude == val && cmd == command) return false;
	    constantAmplitude = val; 
	    break;
	case RICKER:
	    if (rickerFrequency == val && cmd == command) return false;
	    rickerFrequency = val;
	    break;
	case MOVINGAVERAGE:
	    if (movingAverageWindow == val && cmd == command) return false;
	    movingAverageWindow = val; 
	    break;
	case DISCRETIZATION:
	    if (discretizationFrequency == val && cmd == command) return false;
	    discretizationFrequency = val; 
	    break;
	case RECONSTRUCTION:
	    if (reconstructionFrequency == val && cmd == command) return false;
	    reconstructionFrequency = val; 
	    break;
	case FIR2CAUS:
	    if (fir2causFdig == val && cmd == command) return false;
	    fir2causFdig = val; 
	    break;
	case BUTTERWORTH_LP:
	    if (cmd == command && butterworthLPLowFrequncy == val) return false;
	    butterworthLPLowFrequncy = val;
	    break;
	case BUTTERWORTH_HP:
	    if (cmd == command && butterworthHPHighFrequncy == val) return false;
	    butterworthHPHighFrequncy = val;
	    break;
	case DATATRACE:
	    dataTraceFrequency = val;
	    break;
	case DIFFERENCEEQUATION:
	    diffEquGain = val;
	    break;
    }
    command = cmd;
    return true;
  }

  boolean saveParameter (Command cmd, int val1, int val2)
  {
    switch (cmd.id) {
	case DECIMATE:
	    if (command == cmd && decimateFactor == val1 && decimateForce == val2)
		return false;
	    decimateFactor = val1;
	    decimateForce = val2;
	    break;
	case PLAINADCQUANTIZED:
        case PLAINADCMANTISSA:
        case PLAINADCEXPONENT:
        case PLAINADCERROR: 
	     if (command == cmd && plainADCMantissa == val1 && plainADCExponent == val2)
		return false;
	    plainADCMantissa = val1;
	    plainADCExponent = val2;
	    break;
    }
    command = cmd;
    return true;
  }

  boolean saveParameter (Command cmd, double val1, double val2)
  {
    switch (cmd.id) {
	case SEISMOMETER_DIDR:
        case SEISMOMETER_ASDR:
        case SEISMOMETER_ASVR:
	    if (cmd == command && seismometerFrequency == val1 &&
		seismometerDamping == val2) return false;
	    seismometerFrequency = val1;
	    seismometerDamping = val2;
	    break;
    	case BUTTERWORTH_BP:
	    if (cmd == command && butterworthBPLowFrequncy == val1 &&
		butterworthBPHighFrequncy == val2) return false;
	    butterworthBPLowFrequncy = val1;
	    butterworthBPHighFrequncy = val2;
	    break;
    }
    command = cmd;
    return true;
  }

  boolean saveParameter (Command cmd, double v1, double v2, double v3)
  {
   switch (cmd.id) {
	case SINUS:
	    if (sinusAmplitude == v1 && sinusFreqency == v2 && sinusPhase == v3 &&
		cmd == command) return false;
	    sinusAmplitude = v1;
	    sinusFreqency = v2;
	    sinusPhase = v3;
	    break;
	case PLAINADCQUANTIZED:
        case PLAINADCMANTISSA:
        case PLAINADCEXPONENT:
        case PLAINADCERROR: 
	     if (command == cmd && plainADCFrequency == v1 && plainADCGain == v2
		&& plainADCLSB == v3) return false;
	    plainADCFrequency = v1;
	    plainADCGain = v2;
    	    plainADCLSB = v3;
	    break;
    }
    command = cmd;
    return true;
  }

  void saveParameter (Command cmd, double v1, double v2,
		      double v3, double v4, double v5, double v6)
  {
    switch (cmd.id) {
	case MIXED:
	    mixedAmplitude = v1;
	    mixedFrequency = v2;
	    mixedPhase = v3;
	    mixedB = v4;
	    mixedC = v5;
	    mixedD = v6;
	    break;
	case BRUNE:
	    bruneRth = v1;
	    bruneSigma = v2;
	    bruneMu = v3;
	    bruneVs = v4;
	    bruneR = v5;
	    bruneZ = v6;
	    break;
	case CHIRP:
	    chirpAmplitude = v1;
	    chirpFrequency1 = v2;
	    chirpPhase = v3;
	    chirpFrequency2 = v4;
	    break;
      }
  }

  public int find_next_nfft ()
  {
    int n_nfft = 1;
    while(n_nfft < (2*setupPoints))
        n_nfft *= 2;
    return (n_nfft);
  } 
}