//
// Elke Schmidtke, University of Potsdam
// eschmidt@geo.uni-potsdam.de

import java.lang.Math;

public class ComplexValue { 
  float r;
  float i;

    public ComplexValue ()
    {
    	r = 0;
	i = 0; 
    }
    
    public ComplexValue (double real, double imag)
    {
    	r = (float)real;
	i = (float)imag; 
    }
    
    public ComplexValue (float real, float imag)
    {
    	r = real;
	i = imag;
    }  

    public void Csub (ComplexValue b)
    { 
	r -= b.r;
	i -= b.i;
    }

    public void Cmul (ComplexValue b)
    {
	float rr = (r*b.r) - (i*b.i);
	float ii = (i*b.r) + (r*b.i);
	r = rr;
	i = ii;
    }

    public void Cdiv (ComplexValue b)
    {
     float rr, rr1, den;
	if (Math.abs (b.r) >= Math.abs (b.i))
	{
	    rr = b.i / b.r;
	    den = b.r + rr * b.i;
	    rr1 = (r + rr * i)/den;
	    i = (i - rr * r)/den;
	    r = rr1;
	}
	else
	{
	    rr = b.r/b.i;
	    den = b.i + rr * b.r;
	    rr1 = (r * rr + i)/den;
	    i = (i * rr - r)/den;
	    r = rr1;
	}
    }   
}