//
// Elke Schmidtke, University of Potsdam
// eschmidt@geo.uni-potsdam.de

import java.lang.*;
import java.io.*;
import java.net.*;
import java.util.*;
import java.awt.Cursor;

public class ConnectToServer {
  WinGroup wg;
  double fdig, time_tag, a[], b[];  
  int no_ar, no_ma;  
  
    ConnectToServer (WinGroup w)
    {
	wg = w;
    }
    
    // Read data trace				        	
    public double [] ReadDataFile(String url)
    {
      String help;
      BufferedReader instr;
      URL url_file;
      int i, j;
      double [] t;
      
	wg.editor.setCursor(new Cursor(Cursor.WAIT_CURSOR));
	try
	{
	    url_file = new URL (url);
	    instr = new BufferedReader(new InputStreamReader(url_file.openStream()));
	    i = 0;
	    while ((help = instr.readLine()) != null) 
		if (!help.startsWith("#"))
	    	   i++;
	    t = new double[i];
	    instr = new BufferedReader(new InputStreamReader(url_file.openStream()));
	    for (j = 0; j < i; j++)
	    {
		help = instr.readLine();
		if(help.startsWith("#"))
		    continue;
	        t[j] = (Double.valueOf(help)).doubleValue();
	    }	
	}
	catch (Exception ex)
	{
	    wg.message.setVisible (ex.toString());
	    return null;	
	}  
	wg.editor.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
	return (t);
    }	
    
    // Read FIR File
    public boolean readFIRFile (String file)
    {
       URL url = null;	
       String help, sub;
       int i, sp;
       StringTokenizer st;
      	wg.editor.setCursor(new Cursor(Cursor.WAIT_CURSOR));
	String url_string = wg.tutor.codeBase+wg.Dir_FIR+file;
	try
	{
	    url = new URL (url_string);
	    BufferedReader instr = new BufferedReader (new InputStreamReader(url.openStream()));
	    do
		help = instr.readLine();
	    while (!(help.trim()).regionMatches (0,"#FDIG_EFF",0, 9));
	    do
		help = instr.readLine();
	    while ((help.trim()).length() == 0);	
	    fdig = (Double.valueOf(help)).doubleValue();
	        
	    do
		help = instr.readLine();
	    while (!(help.trim()).regionMatches (0,"#CORR_AR",0, 8));
	    do
	   	help = instr.readLine();
	    while ((help.trim()).length() == 0);
	    no_ar = (Integer.valueOf(help)).intValue();
	    
	    a = new double [no_ar+1];
	    do
		help = instr.readLine();
	    while (!(help.trim()).regionMatches (0,"#CORR_AR_DATA",0, 13));  
	    i = 1;
	    do {
		st = new StringTokenizer (instr.readLine());
		while (st.hasMoreTokens()) {
		    sub = st.nextToken();
		    a[i++] = (Double.valueOf(sub)).doubleValue();
		}
	    } while (i <= no_ar);
    
	    do
		help = instr.readLine();
	    while (!(help.trim()).regionMatches (0,"#CORR_MA",0, 8));  
	    help = instr.readLine();
	    no_ma = (Integer.valueOf(help.trim())).intValue();
	    b = new double [no_ma];
	    
	    do
		help = instr.readLine();
	    while (!(help.trim()).regionMatches (0,"#CORR_MA_DATA",0, 13));
	    i = 0;		        
	    do {
		st = new StringTokenizer (instr.readLine());
		while (st.hasMoreTokens()) {
		    sub = st.nextToken();
		    b[i++] = (Double.valueOf(sub)).doubleValue();
		}
	    }  
	    while (i < no_ma);  
	
	    do
		help = instr.readLine();
	    while (!(help.trim()).regionMatches (0,"#TIMETAG",0, 8));  
	    help = instr.readLine();
	    help.trim();
	    time_tag = (Double.valueOf(help)).doubleValue();
	}    
	catch (Exception e)
	{
	    wg.message.setVisible (url+" "+e.toString());
	    return false;
		
	}
	wg.editor.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
	return true;  
    }	
    
    // Read contens of a directory
    // read either ordinary files or directorys 
    protected Vector getFileList(String Directory, boolean if_directory)
    {
      int a,e,p,r,t;
      String help;
      URL dataSource;
      URLConnection conn;
      Vector v = new Vector();
      	wg.frame.setCursor(new Cursor(Cursor.WAIT_CURSOR));
	try
	{
	    dataSource = new URL (Directory);
	}    
	catch (Exception ex)
	{
	    wg.message.setVisible (ex.toString());
	    wg.frame.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
	    return (null);	
	} 
	try
	{ 
	    BufferedReader indir = new BufferedReader (new InputStreamReader(dataSource.openStream()));
	    String buffer = new String();
	    help = new String();
	    while ((buffer = indir.readLine()) != null)
		help += buffer;
	    if ((t = help.indexOf("<hr>")) == -1 &&
		(t = help.indexOf("<br>")) == -1 &&
		(t = help.indexOf("<HR>")) == -1 &&
		(t = help.indexOf("<BR>")) == -1)
		t = 0;
	    for (r = 0; t < help.length(); t = (r < p) ? p+8 : r+5) {
		if ((r = help.indexOf("src=\"", t)) == -1 &&
		    (r = help.indexOf("SRC=\"", t)) == -1)
		    break;
		if ((p = help.indexOf("A HREF=\"", t)) == -1 &&
		    (p = help.indexOf("a href=\"", t)) == -1) 
		    break;
		a = help.indexOf ("\"", r+5);
		String what = help.substring (r+5, a);
		a = help.indexOf ("\"", p+8);
		String file = help.substring (p+8, a); 
		int m = file.lastIndexOf ('/');
		if (m == file.length() - 1)
		    file = file.substring (0, m);
		m = file.lastIndexOf ('/');
		String str = file.substring (m != -1 ? m+1 : 0, file.length());

		if (if_directory) {
		    if (what.indexOf("folder.gif") != -1 || what.indexOf("directory.gif") != -1 ||
			what.indexOf("menu") != -1 ||
		        (what.indexOf("Directory") != -1 && what.indexOf("Parent Directory") == -1))
		        v.addElement ((Object)str);
	        }
		else
		    if (what.indexOf("unknown.gif") != -1 || what.indexOf("file.gif") != -1 ||
			what.indexOf("unknown") != -1 ||
			what.indexOf("compressed.gif") != -1) // neccesary for *.Z-files
			v.addElement ((Object)str);
		}
	}
	catch (Exception ex)
	{
	    wg.message.setVisible (ex.toString());
	    wg.frame.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
	    return (null);
	}  
	wg.frame.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));  
	return (v);	
    }		
    
   // Read GSE calibration Values from file
    public boolean CalibrationFromFile (URL url, CalibrationValues cali)
    {
      String help, sub;
      int i, j;      
  
	wg.editor.setCursor(new Cursor(Cursor.WAIT_CURSOR));
	try
	{
	    BufferedReader instr = new BufferedReader (new InputStreamReader(url.openStream()));
	    i = 0;
	    if ((help = instr.readLine()) == null ||
		!help.regionMatches (0,"CAL1",0,4) ||
		!help.regionMatches (31,"PAZ",0,3))
	    {
		wg.message.setVisible ("No valid data in "+url);
		wg.frame.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
		return false;
	    }
	    help = instr.readLine();
	    cali.numOfPoles = (Integer.valueOf(help = help.trim())).intValue(); 
	    cali.poles = new ComplexValue [cali.numOfPoles];	  
	    for (i = 0; i < cali.numOfPoles; i++)
	    { 
		help = instr.readLine();
		help = help.trim();
		j = help.length();
		j--;
		while (help.charAt(j) != '+' && help.charAt(j) != '-' && help.charAt(j) != ' ')
		    j--;
		sub =  help.substring(0,j);
		sub = sub.trim();   
		cali.poles[i] = new ComplexValue
				((Double.valueOf(sub)).doubleValue(),
				 (Double.valueOf(help.substring (j))).doubleValue());
	    }	
	    help = instr.readLine();
	    cali.numOfZeros = (Integer.valueOf(help = help.trim())).intValue(); 
	    cali.zeros = new ComplexValue [cali.numOfZeros];	  
	    for (i = 0; i < cali.numOfZeros; i++)
	    { 
		help = instr.readLine();
		help = help.trim();
		j = help.length();
		j--;
		while (help.charAt(j) != '+' && help.charAt(j) != '-' && help.charAt(j) != ' ')
		    j--;
		sub =  help.substring(0,j);
		sub = sub.trim();     
		cali.zeros[i] = new ComplexValue
				((Double.valueOf(sub)).doubleValue(),
				 (Double.valueOf(help.substring (j))).doubleValue());
	    }	
	    help = instr.readLine();
	    cali.scaleFak = (Float.valueOf(help = help.trim())).floatValue();
	}
	catch (Exception e)
	{
	    wg.message.setVisible (url+" "+e.toString());
	    wg.frame.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
	    return false;
	}
	wg.editor.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
	return true;  
    }	 	
}