//
// Elke Schmidtke, University of Potsdam
// eschmidt@geo.uni-potsdam.de

public interface Definitions {

    static final String aboutHSt = "About";
    static final String fileHSt = "File";
    static final String polzerHSt = "Poles/Zeros";
    static final String respHSt = "Show Response";
    static final String signHSt = "Test Signals";
    static final String utilHSt = "Utilities";
    static final String setupHSt = "Setup";
    static final String hintsHSt = "Hints";
    
    static final String exitSt = "Exit";
    static final String okSt = "Ok";
    static final String applySt = "Apply";
    static final String cancelSt = "Cancel";
    static final String resetSt = "Reset";
    
    static final String testSignalsMenuSt = "Test Signals";
    
    static final String amplitudeSt = "Amplitude A";
    static final String frequencySt = "Frequency F [Hz]";
    static final String phaseSt = "Phase PHI [Deg]";
    static final String samplingFrequencySt = "internal sampling frequency ";
    
    static final int SPECTRUM = 50;
    static final int FREQUENCYRESPONSE = 60;
    static final int AMPL = 1;
    static final int PHAS = 2;
    static final int REAL = 3;
    static final int IMAG = 4;
    static final int GROU = 5;
    static final int PHDE = 6;
    static final String responseSt = "Response";
    static final String frequencyResponseSt = "Frequency Response";
    static final String spectrumSt = "Spectrum";
    static final String specAmplitudeSt = "Amplitude";
    static final String specPhaseSt = "Phase";
    static final String specRealSt = "Real part";
    static final String specImaginarySt = "Imaginary part";
    static final String specGroupDelaySt = "Group delay";
    static final String specPhaseDelaySt = "Phase delay";

    static final int IMPULSERESPONSE = 2;
    static final String impulseResponseSt = "Impulse Response";

    static final int STEPRESPONSE = 3;
    static final String stepResponseSt ="Step Response";
    
    static final int IMPULSE = 4;
    static final int STEP = 5;
    
    static final int SINUS = 6;
    static final String sinusSt = "Sine/Cosine";
    static final String sinusTitelSt = "Test Signal: Sine/Cosine ";
    static final String sinusMainLabelSt = "Signal:  A * SIN(2*PI*F*T_SAMP + PHI)";
    
    static final int BRUNE = 7;
    static final String bruneSt = "Brune Source";
    static final String bruneTitelSt = "Test Signal: Brune Source ";
    static final String bruneMainLabelSt = "Brune Signal: 2*rth*(sig/mu)*vs*(r/z)*t*exp(-2.34*(vs/r)*t)";
    static final String bruneRthSt = ("rth");
    static final String bruneSigmaSt = ("sigma [bar]");
    static final String bruneMuSt = ("mu [Pa]");
    static final String bruneVsSt = ("vs [km/sec]");
    static final String bruneRSt = ("r [km]");
    static final String bruneZSt = ("z [km]");
    
    static final String seismometerSt = "Seismometer";
    static final int SEISMOMETER_DIDR = 8;
    static final String seismometerDidrSt = "Displacement impulse -> displacement response";
    static final int SEISMOMETER_ASDR = 9;
    static final String seismometerAsdrSt = "Acceleration step -> displacement response";
    static final int SEISMOMETER_ASVR = 10;        static final String seismometerAsvrSt = "Acceleration step -> velocity response";
    static final String seismometerTitelSt = "Test Signal: Seismometer ";
    static final String seismometerMainLabelSt = "Seismometer impulse response";
    static final String seismometerFrequencySt = "Eigenfrequency [Hz]";
    static final String seismometerDampingSt = "Damping (< 1.0)";
    
    static final int SPIKES = 11;
    static final String spikesSt = "Spike(s)";
    static final String spikesTitelSt = "Test Signal: Spikes ";
    static final String spikesMainLabelSt = "Spike(s)";
    static final String spikesPositionSt = "index of position";
    
    static final int CONSTANT = 12;
    static final String constantSt = "Constant";
    static final String constantTitelSt = "Test Signal: Constant ";
    static final String constantMainLabelSt = "Amplitude for constant test signal";
  
    static final int MIXED = 13;
    static final String mixedSt = "Mixed Signal";
    static final String mixedTitelSt = "Test Signal: Mixed Signal ";
    static final String mixedMainLabelSt = "Signal: A*sin(2*PI*F*t+PHI)*exp(-B*t)+C+D*t";
    static final String mixedBSt = ("B");
    static final String mixedCSt = ("C");
    static final String mixedDSt = ("D");
    
    static final int RICKER = 14;
    static final String rickerSt = "Ricker Wavelet";
    static final String rickerTitelSt = "Test Signal: Ricker Wavelet ";
    static final String rickerMainLabelSt = "Domain frequency for Ricker Wavelet";
    
    static final int CHIRP = 15;
    static final String chirpSt = "Chirp Signal";
    static final String chirpTitelSt = "Test Signal: Chirp Signal ";
    static final String chirpMainLabelSt = "Signal: A*sin(2*PI*F(t)*t+PHI),  F1 <= F(t) <= F2";
    static final String chirpFrequency1St = "Frequency F1 [Hz]";
    static final String chirpFrequency2St = "Frequency F2 [Hz]";
    
    static final int DISCRETIZATION = 17;
    static final String discretizationSt = "Simulate discretization in time";
    static final String discretizationTitelSt = "Discretization ";
    static final String discretizationFrequencySt = "Discretization frequency [Hz]";
    
    static final int RECONSTRUCTION = 18;
    static final String reconstructionSt = "Reconstruction of discretized signal";
    static final String reconstructionTitelSt = "Reconstruction ";
 
    static final int PLAINADCQUANTIZED = 21;
    static final int PLAINADCMANTISSA = 22;
    static final int PLAINADCEXPONENT = 23;
    static final int PLAINADCERROR = 24;
    static final String plainADCSt = "Plain A/D Converter";
    static final String plainADCQuantizedSt = "Quantized Value (mant * 2**exp)";
    static final String plainADCMantissaSt = "Mantissa";
    static final String plainADCExponentSt = "Exponent (PGA deamplification)";
    static final String plainADCErrorSt = "Error signal";
    static final String plainADCFrequencySt = "old: ";
    static final String plainADCGain1St = "static pre-amplifier gain";
    static final String plainADCGain2St = "1.0 ignores pre-amp";
    static final String plainADCMantissa1St = "no. of bits for mantissa (resolution)";
    static final String plainADCMantissa2St = "between 2 (1 for sign bit) and 29";
    static final String plainADCLSBSt = "LSB value";
    static final String plainADCExponent1St = "no. of bits for exponent";
    static final String plainADCExponent2St = "0 turns off PGA";
    
    static final int DIFFERENCEEQUATION = 25;
    static final String differenceEquationSt = "Difference Equation ";
    static final String differenceEquationTitelSt = "Difference Equation ";
    static final String differenceEquationARCoefSt = "autoregressive coefficients (a)";
    static final String differenceEquationMACoefSt = "moving average coefficients (b)";
    static final String differenceEquationGainSt = "Gain Factor";
    static final String differenceEquationInvSt = "Filtering inverse";
    
    static final int FILTERWITHGSECALIB = 26;
    static final String filterWithGseCalibSt = "Filter with Response from Poles/Zeros ";
    static final String filterWithGseCalibTitelSt = "Filter with Response from Poles/Zeros ";
    static final String numberOfPointsForFFTSt = "Number of points for FFT";
    
    static final int DELTAMODULATION = 29;
    static final int DELTAMODULATIONRESULT = 30;
    static final String deltaModulationSt = "Delta Modulation ";
    static final String deltaModulationResultSt = "Delta Modulation Result";
    static final String deltaModulationTitelSt = "Delta Modulation ";
    static final String modulationLSBSt = "Least significant bit (LSB)";
    static final String deltaModulationPredictorSt = "Predictor Mode:";
    static final String deltaModulationSummationSt = "Summation";
    static final String deltaModulationIntegrationSt = "Integration";

    static final int PLAINSUMMATION = 31;
    static final String plainSummationSt = "Plain summation";
    static final int INTEGRATION = 32;  
    static final String integrationSt = "Integration";
      
    static final int MOVINGAVERAGE = 33;
    static final String movingAverageSt = "Moving Average ";
    static final String movingAverageTitelSt = "Moving Average ";
    static final String movingAverageWindowSt = "Width of averaging window [s]";
    
    static int  DECIMATIONFILTERING = 34;
    static final String decimationFilteringSt = "Decimation filtering ";
    static final String decimationFilteringResampSt = "Resampling:";
    static final String decimationFilteringResampOnSt = "on";
    static final String decimationFilteringResampOffSt = "off";
    
    static final int SIGMADELTAMODULATION = 35;
    static final String sigmaDeltaModulationSt = "Sigma Delta Modulation ";
    static final String sigmaDeltaModStep2 = "Linear phase FIR filter";
    static final String sigmaDeltaModStep3 = "Decimation and phase shift correction";
    static final String sigmaDeltaModulationTitelSt = "Sigma Delta Modulation ";
    static final String decimationRatioSt = "Decimation ratio:";
    static final String decimationR2St = "2";
    static final String decimationR4St = "4";
    static final String decimationR10St = "10";
    static final String decimationR16St = "16";
    static final String sigmaDeltaModulationDisplayModeSt = "Display mode:";
    static final String sigmaDeltaModulationDisplayCombSt = "Comb";
    static final String sigmaDeltaModulationDisplatBarSt = "Bar";
    
    static int DATATRACE = 38;
    static final String dataTraceSt = "Data Trace ";
    static final String openDataTraceSt = "Open File with Data Trace ";
    static final String dataTraceTitleSt = "Read Data Trace";
    static final String dataTraceFoldersSt = "Folders";
    static final String dataTraceFilesSt = "Files";
    static final String dataTraceSamplingFrequencySt = "Sampling frequency [Hz]";
    
    static final int INTERPOLATE = 39;
    static final String interpolateSt = "Interpolate ";
    static final String interpolateTitelSt = "Interpolate ";
    static final String interpolationFactorSt = "Interpolation factor";

    static final int DECIMATE = 40;
    static final String decimateSt = "Decimate ";
    static final String decimateTitelSt = "Decimate ";
    static final String decimateFactorSt = "Decimation factor";
    static final String decimateForceSt = "Force decimation to include this sample";
    
    static int FIR2CAUS = 41;
    static final String fir2causSt = "FIR2CAUS ";
    static final String fir2causTitelSt = "FIR2CAUS ";
    static final String fir2causCoorFilterFileSt = "Correction filter file";
    static final String fir2causFdigSt = "Fdig of input trace";
    static final String fir2causFdig1St = "(-1: reads value from correction filter file)";
    static final String fir2causZerosAppendSt = "Number of zeros to pre / append";
    static final String fir2causCorrectLinearPhasesSt = "Correct for linear phase";
    static final String fir2causCorrectLinearPhaseYesSt = "Yes";
    static final String fir2causCorrectLinearPhaseNoSt = "No";

    static final String butterworthFilterSt = "Butterworth Filter";
    static final String butterworthSt = "Butterworth ";
    static final String butterworthFilSt = "Filter";
    static final String butterworthForwardSt = "forward";
    static final String butterworthBackwardSt = "forward/backward";
    static final String butterworthSectionsSt = "Sections";
    static final int butterworthMAXSEC = 10;
    
    static int BUTTERWORTH_BP = 46;
    static final String butterworthBPSt = "Bandpass";
    static final String butterworthBPLCSt = "Low cut frequency [Hz]";
    static final String butterworthBPHCSt = "High cut frequency [Hz]";
    
    static int BUTTERWORTH_LP = 47;
    static final String butterworthLPSt = "Lowpass";
    static final String butterworthLPLPSt = "Low pass frequency [Hz]"; 
     
    static int BUTTERWORTH_HP = 48;
    static final String butterworthHPSt = "Highpass";
    static final String butterworthHPHPSt = "High pass frequency [Hz]"; 
    
    static final int DIFFERENTIATE = 49;
    static final String differentiateSt = "Differentiate";
    
    static int GSECALIBRATIONFILE = 90;
    static final String openGseCalibrationFileSt = "Open File with GSE Calibration";
    static final String chooseGseCalibrationSt = "Choose from file";
    static final String openGseCalibrationFileTitleSt = "Open File with GSE Calibration";
    static final String chooseGseCalibrationFileSt =  "Choose File";

    static final int SAVEIMAGE = 91;
    static final String saveImageSt = "Save Image in new Window";
    static final String labelForImageSt = "Label for new Window";

    static final String setupTitelSt = "Setup ";
    static final int SETUPRESET = 101;
    static final String setupResetSt = "Reset";
    static final int SETUPMODIFY = 100;
    static final String setupModifySt = "Modify";
    static final String setupPointsSt = "window length (number of points for FFT)";
    static final String setupSpikeSt = "spike position for impulse response";
    static final String setupStepSt = "step position for step response";
    static final double setupDefaultFrequency = 20;
    static final int setupDefaultPoints = 2048;
    static final int setupDefaultSpike = 1024;
    static final int setupDefaultStep = 1024;
    
 }
    