//
// Elke Schmidtke, University of Potsdam
// eschmidt@geo.uni-potsdam.de

import java.awt.*;
import java.awt.event.*;
import java.util.Vector;
import java.net.*;

public class MainBar extends MenuBar implements ActionListener, Definitions
{
    private Tutor app;
    private WinGroup wg;
      
    MenuItem FreqRespAmplitudelinlog = new MenuItem ("lin-log");
    MenuItem FreqRespAmplitudeloglog = new MenuItem ("log-log");
    MenuItem FreqRespPhaselinlog = new MenuItem ("lin-log");
    MenuItem FreqRespPhaseloglog = new MenuItem ("log-log");
    MenuItem FreqRespReallinlog = new MenuItem ("lin-log");
    MenuItem FreqRespRealloglog = new MenuItem ("log-log");
    MenuItem FreqRespImaglinlog = new MenuItem ("lin-log");
    MenuItem FreqRespImagloglog = new MenuItem ("log-log");
    MenuItem FreqRespGrouplinlog = new MenuItem ("lin-log");
    MenuItem FreqRespGrouploglog = new MenuItem ("log-log");
    MenuItem FreqRespPhasedlinlog = new MenuItem ("lin-log");
    MenuItem FreqRespPhasedloglog = new MenuItem ("log-log");
    MenuItem SpectrumAmplitudelinlog = new MenuItem ("lin-log");
    MenuItem SpectrumAmplitudeloglog = new MenuItem ("log-log");
    MenuItem SpectrumPhaselinlog = new MenuItem ("lin-log");
    MenuItem SpectrumPhaseloglog = new MenuItem ("log-log");
    MenuItem SpectrumReallinlog = new MenuItem ("lin-log");
    MenuItem SpectrumRealloglog = new MenuItem ("log-log");
    MenuItem SpectrumImaglinlog = new MenuItem ("lin-log");
    MenuItem SpectrumImagloglog = new MenuItem ("log-log");
    MenuItem Reconstruction = new MenuItem ("Reconstruction of discretized signal");
    
    Vector fitResponseFiles = null;
    
    String responseType = null;
    int axisType = 0;
    
    public void actionPerformed (ActionEvent e)
    {
        Reconstruction.setEnabled (false);
        MenuItem item = (MenuItem)e.getSource();
	String s = e.getActionCommand();
        String parent = ((Menu)item.getParent()).getLabel();
	    
        if (s.equals (saveImageSt))
        {
	    int id = wg.settings.newSettings (s);
	    wg.editor.newSettings (wg.settings, new SaveImageCommand (id, wg));
	    wg.editor.showIt();
	    return;
	}
	    
	for (int i = 0; i < fitResponseFiles.size(); i++)
	{ 
	    if (s.equals ((String)fitResponseFiles.elementAt (i)))
	    {
		try
		{	
		    URL url_file = new URL (wg.tutor.codeBase+wg.Dir_Exercise+s);
		    wg.ServerConnection.CalibrationFromFile (url_file, wg.FitResponseCalVal);
		}  
		catch (Exception ex)
		{
		    wg.message.setVisible (ex.toString());
		}
		wg.actionPerformed (new ActionEvent (wg, Event.ACTION_EVENT, "fitResponse"));
		return;
	    }
	}
	if (s.equals ("Delete Response for Fit"))
	{
	    wg.FitResponseCalVal.deleteCalibration();;
	    wg.frame.graph.DeleteSecondPlotTrace ();
	    return;
	}
		
	else if (s.equals(openGseCalibrationFileSt) || s.equals(chooseGseCalibrationSt)) {
	    int id = wg.settings.newSettings (s);
	    wg.editor.newSettings (wg.settings, new NewValuesCommand (id, wg));
	    wg.editor.showIt();
	}
		
	else if (parent.equals ("Print"))
	{
	    if (!wg.printWin.isVisible()) wg.printWin.setVisible (s);
	}	
	
	else if (s.equals ("Modify and Enter"))
	{
	    if (wg.CalVal.haveCalibration())
		wg.PolesZeros.newValues(wg.CalVal);
	    if (!wg.PolesZeros.isVisible()) wg.PolesZeros.setVisible (true);
	}	
	
	else if (s.equals ("Map"))
	{ 
	    if (!wg.CalVal.haveCalibration())
	    {
		wg.message.setVisible ("No calibration given");
		return;
	    }  
	    if (!wg.showPolZer.isVisible()) wg.showPolZer.setVisible (true);
	}
	    
	else if (parent.equals(setupTitelSt))
	{
	    int id = wg.settings.newSettings (s);
	    wg.editor.newSettings (wg.settings, new SetupCommand (id, wg));
	    wg.editor.showIt();
	}
	    
	else if (s.equals("lin-lin") || s.equals("lin-log") ||
	    s.equals("log-lin") ||s.equals("log-log") ||
	    s.equals (impulseResponseSt) || s.equals (stepResponseSt))
	{
	    ResponseCommand rC;
	    if (s.equals(impulseResponseSt) || s.equals(stepResponseSt))
		rC = new ResponseCommand (wg, s);
	    else {
		axisType = AxisType (s);
		responseType = parent;
		rC = new ResponseCommand 
		    (wg, ((Menu)((Menu)item.getParent()).getParent()).getLabel(),
		        parent, axisType);
	    }
	    rC.actionPerformed(new ActionEvent (wg, Event.ACTION_EVENT, responseSt));
	}
	else if (parent.equals(testSignalsMenuSt) || 
		 parent.equals(seismometerSt) ||
		 s.equals (dataTraceSt) || 
		 s.equals(openDataTraceSt)) {
	    int id = wg.settings.newSettings (s);
	    wg.editor.newSettings (wg.settings, new TraceCommand (id, wg));
	    wg.editor.showIt();
	}
		
	else	// need data to proceed		
	{
	    if (wg.frame.graph.t.getId() == -1) {
		wg.message.setVisible ("No data to proceed !");
		return;
	    } 
	    else if (s.equals (discretizationSt) ||
		     s.equals (reconstructionSt) ||
		     s.equals (interpolateSt) ||
		     s.equals (movingAverageSt) ||
		     s.equals (decimateSt) ||
		     s.equals (deltaModulationSt) ||
		     s.equals (sigmaDeltaModulationSt) ||
		     s.equals (plainSummationSt) || 
		     s.equals (integrationSt) ||
		     s.equals (differenceEquationSt) ||
		     s.equals (plainADCQuantizedSt) ||
		     s.equals (plainADCMantissaSt) ||
		     s.equals (plainADCExponentSt) ||
		     s.equals (plainADCErrorSt) ||
		     s.equals (decimationFilteringSt) ||
		     s.equals (fir2causSt) ||
		     s.equals (filterWithGseCalibSt) ||
		     s.equals (butterworthBPSt) ||
		     s.equals (butterworthLPSt) ||
		     s.equals (butterworthHPSt) ||
		     s.equals (differentiateSt)) {
		    if (s.equals (filterWithGseCalibSt) && !wg.CalVal.haveCalibration()) {
			wg.message.setVisible ("No calibration given");
			return;
		    }
		    int id = wg.settings.newSettings (s);
		    wg.editor.newSettings (wg.settings, new ProccedCommand (id, wg));
		    wg.editor.showIt();
		}
	}   

    }
  
   private void addNewMenuItem (Menu menu, String name, ActionListener listener)
   {
      MenuItem item = new MenuItem (name);
      item.setActionCommand(name);
      item.addActionListener(listener);
      menu.add(item);
   } 
    
   private void addNewMenuItem (Menu menu, MenuItem item, ActionListener listener)
   {
      item.setActionCommand(item.getLabel());
      item.addActionListener(listener);
      menu.add(item);
   }
   
   private void addNewMenuPoint (Menu main, String Name, MenuItem linlog, MenuItem loglog,
	     ActionListener listener)
   {
      Menu newMenu = new Menu (Name);
      addNewMenuItem (newMenu, "lin-lin", listener); 
      addNewMenuItem (newMenu, linlog, listener);
      addNewMenuItem (newMenu, "log-lin", listener);
      addNewMenuItem (newMenu, loglog, listener);
      main.add (newMenu);
      linlog.setEnabled(false);
      loglog.setEnabled(false);
   }
   
 // Constructor       
    MainBar (Tutor a, WinGroup w)
    {
	wg = w;
	app = a;
	fitResponseFiles = wg.ServerConnection.getFileList(wg.tutor.codeBase+wg.Dir_Exercise, false);
	
	Menu menuFile = new Menu("File");
	addNewMenuItem (menuFile, openGseCalibrationFileSt, this);
	addNewMenuItem (menuFile, openDataTraceSt, this);
	addNewMenuItem (menuFile, ("Reset"), wg);
	Menu menuPrint = new Menu("Print");
	addNewMenuItem (menuPrint, "Description for SUN Solaris", this);
	addNewMenuItem (menuPrint, "Description for Linux (Red Hat)", this); 
	addNewMenuItem (menuPrint, "Description for Windos", this);
	menuFile.add (menuPrint);
	menuFile.addSeparator();
	addNewMenuItem (menuFile, "New Window", app);
	addNewMenuItem (menuFile, saveImageSt, this);
	menuFile.addSeparator();
	addNewMenuItem (menuFile, "Exit", wg);
	add (menuFile);
	Menu menuPolesZeros = new Menu ("Poles/Zeros");
	addNewMenuItem (menuPolesZeros, chooseGseCalibrationSt, this);
	addNewMenuItem (menuPolesZeros, "Modify and Enter", this);
	addNewMenuItem (menuPolesZeros, "Map", this);
	Menu fitResponse = new Menu ("Load Response for Fit");
	for (int i = 0; i < fitResponseFiles.size(); i++)
	    fitResponse.add ((String)fitResponseFiles.elementAt (i));
	addNewMenuItem (menuPolesZeros, fitResponse, this);
	addNewMenuItem (menuPolesZeros, "Delete Response for Fit", this);
	add (menuPolesZeros);
	
	Menu menuResponse = new Menu ("Show Response");
	Menu menuFreqResp = new Menu (frequencyResponseSt);
	addNewMenuPoint (menuFreqResp, specAmplitudeSt,
		       FreqRespAmplitudelinlog, FreqRespAmplitudeloglog, this);
	addNewMenuPoint (menuFreqResp, specPhaseSt,
		       FreqRespPhaselinlog, FreqRespPhaseloglog, this);
	addNewMenuPoint (menuFreqResp, specRealSt,
		       FreqRespReallinlog, FreqRespRealloglog, this);
	addNewMenuPoint (menuFreqResp, specImaginarySt,
		       FreqRespImaglinlog, FreqRespImagloglog, this);
	addNewMenuPoint (menuFreqResp, specGroupDelaySt,
		       FreqRespGrouplinlog, FreqRespGrouploglog, this);
	addNewMenuPoint (menuFreqResp, specPhaseDelaySt,
		       FreqRespPhasedlinlog, FreqRespPhasedloglog, this);
	addNewMenuItem (menuResponse, menuFreqResp, this);
	addNewMenuItem (menuResponse, impulseResponseSt, this);
	addNewMenuItem (menuResponse, stepResponseSt, this);
	
	add (menuResponse);
	
	Menu menuTestSignals = new Menu (testSignalsMenuSt);
	addNewMenuItem (menuTestSignals, sinusSt, this);
	addNewMenuItem (menuTestSignals, spikesSt, this);
	addNewMenuItem (menuTestSignals, constantSt, this);
	addNewMenuItem (menuTestSignals, bruneSt, this);
	addNewMenuItem (menuTestSignals, mixedSt, this);
	addNewMenuItem (menuTestSignals, rickerSt, this);
	Menu menuSeismometer = new Menu (seismometerSt);
	addNewMenuItem (menuSeismometer, seismometerDidrSt, this);
	addNewMenuItem (menuSeismometer, seismometerAsdrSt, this);
	addNewMenuItem (menuSeismometer, seismometerAsvrSt, this);
	addNewMenuItem (menuTestSignals, menuSeismometer, this);
	addNewMenuItem (menuTestSignals, chirpSt, this);
	add (menuTestSignals);
	
	Menu menuUtilities = new Menu ("Utilities");
	
	Menu menuDiscretization = new Menu ("Discretization");
	addNewMenuItem (menuDiscretization, discretizationSt, this);
	addNewMenuItem (menuDiscretization, Reconstruction, this);
	Reconstruction.setEnabled (false);
	menuUtilities.add (menuDiscretization);
	
	addNewMenuItem (menuUtilities, integrationSt, this);
	addNewMenuItem (menuUtilities, differentiateSt, this);
	addNewMenuItem (menuUtilities, decimationFilteringSt, this);
	addNewMenuItem (menuUtilities, decimateSt, this);
	
	Menu menuSpectrum = new Menu (spectrumSt);
	addNewMenuPoint (menuSpectrum, specAmplitudeSt,
		       SpectrumAmplitudelinlog, SpectrumAmplitudeloglog, this);
	addNewMenuPoint (menuSpectrum, specPhaseSt,
		       SpectrumPhaselinlog, SpectrumPhaseloglog, this);
	addNewMenuPoint (menuSpectrum, specRealSt,
		       SpectrumReallinlog, SpectrumRealloglog, this);
	addNewMenuPoint (menuSpectrum, specImaginarySt,
		       SpectrumImaglinlog, SpectrumImagloglog, this);
	addNewMenuItem (menuUtilities, menuSpectrum, this);
	
	addNewMenuItem (menuUtilities, deltaModulationSt, this);
	addNewMenuItem (menuUtilities, movingAverageSt, this);
	addNewMenuItem (menuUtilities, sigmaDeltaModulationSt, this);
	addNewMenuItem (menuUtilities, interpolateSt, this);
	addNewMenuItem (menuUtilities, fir2causSt, this);
	
	Menu menuADC = new Menu (plainADCSt);
	addNewMenuItem (menuADC, plainADCQuantizedSt, this);
	addNewMenuItem (menuADC, plainADCMantissaSt, this);
	addNewMenuItem (menuADC, plainADCExponentSt, this);
	addNewMenuItem (menuADC, plainADCErrorSt, this);
	addNewMenuItem (menuUtilities, menuADC, this);
	
	addNewMenuItem (menuUtilities, differenceEquationSt, this);
	addNewMenuItem (menuUtilities, filterWithGseCalibSt, this);
	
	Menu butterworth = new Menu (butterworthFilterSt);
	addNewMenuItem (butterworth, butterworthBPSt, this);
	addNewMenuItem (butterworth, butterworthLPSt, this);
	addNewMenuItem (butterworth, butterworthHPSt, this);
	addNewMenuItem (menuUtilities, butterworth, this);
	
	add (menuUtilities);
	
	Menu menuSetup = new Menu(setupTitelSt);
	addNewMenuItem (menuSetup, setupModifySt, this);
	addNewMenuItem (menuSetup, setupResetSt, this);
	add (menuSetup);
	
	Menu menuHelp = new Menu ("Help");
	addNewMenuItem (menuHelp, aboutHSt, app);
	addNewMenuItem (menuHelp, hintsHSt, app);
	addNewMenuItem (menuHelp, fileHSt, app);
	addNewMenuItem (menuHelp, polzerHSt, app);
	addNewMenuItem (menuHelp, respHSt, app);
	addNewMenuItem (menuHelp, signHSt, app);
	addNewMenuItem (menuHelp, utilHSt, app);
	addNewMenuItem (menuHelp, setupHSt, app);
	setHelpMenu (menuHelp);
  }

  public void  FreqRespEnableDiagramAxis (TraceSpectrum T)
  {
    FreqRespAmplitudelinlog.setEnabled (T.amplitude); 
    FreqRespAmplitudeloglog.setEnabled (T.amplitude); 
    FreqRespPhaselinlog.setEnabled (T.phase); 
    FreqRespPhaseloglog.setEnabled (T.phase); 
    FreqRespReallinlog.setEnabled (T.real); 
    FreqRespRealloglog.setEnabled (T.real); 
    FreqRespImaglinlog.setEnabled (T.imag);
    FreqRespImagloglog.setEnabled (T.imag); 
    FreqRespGrouplinlog.setEnabled (T.groupd); 
    FreqRespGrouploglog.setEnabled (T.groupd);
    FreqRespPhasedlinlog.setEnabled (T.phasedl); 
    FreqRespPhasedloglog.setEnabled (T.phasedl); 
  }

  public void  SpectrumEnableDiagramAxis (TraceSpectrum T)
  {
    SpectrumAmplitudelinlog.setEnabled (T.amplitude); 
    SpectrumAmplitudeloglog.setEnabled (T.amplitude); 
    SpectrumPhaselinlog.setEnabled (T.phase); 
    SpectrumPhaseloglog.setEnabled (T.phase); 
    SpectrumReallinlog.setEnabled (T.real); 
    SpectrumRealloglog.setEnabled (T.real); 
    SpectrumImaglinlog.setEnabled (T.imag);
    SpectrumImagloglog.setEnabled (T.imag); 
  }
  
  public int AxisType (String Axis)
  {
    if (Axis.equals ("lin-lin")) return 0;
    if (Axis.equals ("lin-log")) return 1;
    if (Axis.equals ("log-lin")) return 2;
    if (Axis.equals ("log-log")) return 3;
    return 0;
  }   

}
