//
// Elke Schmidtke, University of Potsdam
// eschmidt@geo.uni-potsdam.de

import java.awt.event.*;

class SetupCommand extends Command 
{ 
    SetupCommand (int id, WinGroup wg) { super (id, wg); }
    
    public void actionPerformed (ActionEvent e)
    {
	String s = e.getActionCommand();
	if (s.equals (cancelSt)) {
	    wg.editor.setVisible(false);
	    return;
	}
	
	switch (id) {
	
	    case SETUPRESET:
		Reset ();
		break;
		
	    case SETUPMODIFY: 
		double frequency =  wg.editor.getDouble (samplingFrequencySt+" [Hz]");
		int points = wg.editor.getInteger (setupPointsSt);
		int spike = wg.editor.getInteger (setupSpikeSt);
	        int step = wg.editor.getInteger (setupStepSt);
		if (frequency != Double.NEGATIVE_INFINITY && points != Integer.MIN_VALUE && 
		    spike != Integer.MIN_VALUE && step != Integer.MIN_VALUE) {
		    // points
		    try {
			double g[] = new double [points];
		    }
		    catch (OutOfMemoryError ex) {
			wg.message.setVisible("number of points is too big");
			return;
		    }  
		    // frequency  
		    if (frequency < 0) {
			wg.message.setVisible ("No valid frequency !");
			return;
		    }
		    // spike position
		    if (spike < 0) {
			wg.message.setVisible ("No valid spike position !");
			return;	
		    }	
		    // step position
		    if (step < 0) {
			wg.message.setVisible ("No valid step position !");
			return;	
		    }
		}
		else return;
		wg.params.saveParameter (this, frequency, points, spike, step);
	}    // end of switch
	    
	if (s.equals (okSt))
	    wg.editor.setVisible(false);
    }
    
    public void Reset()
    {
	wg.params.saveParameter (this, setupDefaultFrequency, setupDefaultPoints,
				 setupDefaultSpike, setupDefaultStep);
    }
}


