//
//   Tutor : Applet     
//  
//	Tutor class is the main class for his applet
//
// Elke Schmidtke, University of Potsdam
// eschmidt@geo.uni-potsdam.de

import java.awt.*;
import java.awt.event.*;
import java.net.URL;
import java.util.Vector;
import java.applet.*;
import java.lang.System;

public class Tutor extends Applet 
implements MouseListener, ActionListener, Definitions
{
  String sDate = "October 23, 2000";
  static Vector wgs = new Vector (1);		// window groups
  static String codeBase;
  AppletContext appContext;
  static boolean application = false;
  int index_num = 0;
  String imageSt = "DST.jpeg";
  Image image;
  
    public void actionPerformed (ActionEvent evt)
    {
      String act = evt.getActionCommand();
      
	if (act.equals ("Loaded"))
	    setCursor (new Cursor (Cursor.DEFAULT_CURSOR));
	else if (act.equals ("START"))  // open Applet window
	{ 
	    if (wgs.size() > 0) {
		WinGroup wg = (WinGroup) wgs.elementAt(0);
		wg.frame.setVisible (true);
		setCursor (new Cursor (Cursor.HAND_CURSOR));
	    }
	    else {
		WinGroup wg = new WinGroup(this, index_num);
		wgs.addElement (wg);
		wg.start();
	    }
	}
	else if (act.equals ("New Window"))
	{
	    WinGroup wg = new WinGroup(this, ++index_num);
	    wgs.addElement(wg);
	    wg.start();
	}
	else if (act.equals (exitSt))	//Exit
	{
	    if (application)
		System.exit(0);
	    else 
		stop();
	}
  	else	    // Show  one of the help pages
	{
	  String st = null;
	    if (act.equals (aboutHSt)) st = "About.html";
	    if (act.equals (fileHSt)) st = "File.html";
	    if (act.equals (polzerHSt)) st = "PolesZeros.html";
	    if (act.equals (respHSt)) st = "Response.html";
	    if (act.equals (signHSt)) st = "Signals.html";
	    if (act.equals (utilHSt)) st = "Util.html";
	    if (act.equals (setupHSt)) st = "Setup.html";
	    if (act.equals (hintsHSt)) st = "Hints.html";
	    if (!application) {
		URL url = null;
		try {
		    url = new URL (codeBase+st);
		}
		catch (Exception ex) { 
		    WinGroup wg = (WinGroup) wgs.elementAt(0);
		    wg.message.setVisible (ex.toString());
		}   
		appContext.showDocument (url,"tutorHelp");
	    }
	    else {
		((WinGroup)wgs.elementAt(0)).message.setVisible 
		    ("Start your browser and load the page '"+st+"' !");
	    }
	}
    }
    
    // Function that is called when running as Application  
    public static void main (String args[])
    { 
	Tutor app = new Tutor ();
	application = true;
	codeBase = "file:"+System.getProperty("user.dir")+System.getProperty("file.separator");
	wgs.removeAllElements();
	app.actionPerformed (new ActionEvent (app, Event.ACTION_EVENT,"START"));
   }	
     
   // Function that is called when running as Applet 
    public void init()
    { 
	URL CodeBase = getCodeBase();
	codeBase = "" + CodeBase;
	image = getImage (CodeBase, imageSt);
	addMouseListener (this);
   }
    
    public void	start()
    {
	wgs.removeAllElements();
	appContext = getAppletContext();
    }
       
    public void paint (Graphics g)
    { 
	update (g);
    }
    
    public void update(Graphics g)
    {
	g.drawString("The Applet Digital Seismology Tutor", 10,getSize().height/2);
	g.drawImage (image, 0, 0, this);
	g.drawString(sDate,10,getSize().height-getSize().height/10);
    }	

    public void stop ()
    {
	for (int i = 0; i < wgs.size(); i++) {
		((WinGroup) wgs.elementAt(i)).hideAll();
		((WinGroup) wgs.elementAt(i)).disposeAll();
		((WinGroup) wgs.elementAt(i)).stop();
	    }
	index_num = 0;
	wgs.removeAllElements();
    }
    
    public void mouseClicked (MouseEvent e) {}
    public void mousePressed (MouseEvent e) {}
    public void mouseExited (MouseEvent e)  { setCursor (new Cursor (Cursor.DEFAULT_CURSOR));}

    public void mouseEntered (MouseEvent e) 
    { 
	setCursor (new Cursor (Cursor.HAND_CURSOR));
	showStatus ("Start the applet \"Digital Seismology Tutor\"");
    }
    
    public void mouseReleased (MouseEvent e)
    { 
	setCursor (new Cursor (Cursor.WAIT_CURSOR));
	actionPerformed (new ActionEvent (this, Event.ACTION_EVENT,"START"));
    }
}