//
// Elke Schmidtke, University of Potsdam
// eschmidt@geo.uni-potsdam.de

import java.awt.*;
import java.util.Vector;
import java.util.StringTokenizer;
import java.awt.event.*;

abstract class WinFrame extends Frame 
implements WindowListener, Definitions, ActionListener
{
  WinGroup wg;
  int width;
  int height;
  GridBagConstraints constraints;
  GridBagLayout gridbag;
      
    WinFrame (WinGroup w, String title)
    {
	wg = w;
	if (wg.index > 0) setTitle (title + wg.index);
	else		  setTitle (title);
	gridbag = new GridBagLayout();
	constraints = new GridBagConstraints();
	constraints.fill = GridBagConstraints.BOTH;
	constraints.weightx = 1.0; 
	constraints.weighty = 1.0;
	setLayout(gridbag);
	addWindowListener(this);
    }
    
    public void setContinue (boolean cont)	  {}
    public void windowDeactivated (WindowEvent e) {}
    public void windowDeiconified (WindowEvent e) {}
    public void windowIconified (WindowEvent e)   {}
    public void windowActivated (WindowEvent e)	  {}
    public void windowClosed (WindowEvent e)	  {}
    public void windowOpened (WindowEvent e)	  {}
    
    public void windowClosing (WindowEvent e)
    { 
	setVisible(false);
	dispose();
    }

    public void makeButton(int x, int y, String name, ActionListener listener) 
    {
	Button button = new Button(name);
	makeComponent (x,y, 1,1, button);
	button.addActionListener (listener);
    }

    public void makeLabel(int x, int y, int w, int h, String name)
    {
	Label label = new Label(name);
	makeComponent (x,y, w,h, label);
    }
         
    public void makeComponent (int x, int y, int w, int h, Component comp)
    {		
	constraints.gridx = x;
        constraints.gridy = y;		  
	constraints.gridwidth = w;	
	constraints.gridheight = h;		      
        gridbag.setConstraints(comp, constraints);
	add(comp);
    }  
    
    public void makeCommandLine3B (int a, ActionListener listener)
    {
	constraints.gridwidth = 1;
	makeButton (0, a, okSt, listener);
	makeButton (1, a, applySt, listener);
	makeButton (2, a, cancelSt, listener);
    }	
     
    public void makeCommandLine4B (int a, ActionListener listener)
    {
	constraints.gridwidth = 1;
	makeButton (0, a, okSt, listener);
	makeButton (1, a, applySt, listener);
	makeButton (2, a, resetSt, listener);
	makeButton (3, a, cancelSt, listener);
    }	
    
    // select false value from error message
    static public String ERR (String error)
    {
	int pos = error.indexOf(':');
	return error.substring(++pos,error.length());
    }
    	
    // select values from a string, put them into a vector
    static public Vector StringToValues (String string)
    { 
      Vector v = new Vector(); 
      String next;
      float wert;
      StringTokenizer st = new StringTokenizer (string, "\t\n\r ,;");
      while (st.hasMoreTokens()) {
	 next = st.nextToken();
	 try {
	    wert = (Float.valueOf(next)).floatValue();
         }
	 catch (NumberFormatException e) {
	    v.removeAllElements();
	    return (v);
         }	
	 v.addElement(next);
      }    
      return (v);
    }
}    